diff -pruN 1.16.4-2/debian/changelog 1.16.4-3/debian/changelog
--- 1.16.4-2/debian/changelog	2024-05-27 16:03:14.000000000 +0000
+++ 1.16.4-3/debian/changelog	2024-05-27 23:26:50.000000000 +0000
@@ -1,3 +1,9 @@
+dqlite (1.16.4-3) unstable; urgency=medium
+
+  * Revert back to an older fix for alpha and x32 FTBFS
+
+ -- Mathias Gibbens <gibmat@debian.org>  Mon, 27 May 2024 23:26:50 +0000
+
 dqlite (1.16.4-2) unstable; urgency=medium
 
   * Cherry-pick upstream fix for FTBFS on alpha and x32
diff -pruN 1.16.4-2/debian/patches/0003-fix-alpha-x32-build.patch 1.16.4-3/debian/patches/0003-fix-alpha-x32-build.patch
--- 1.16.4-2/debian/patches/0003-fix-alpha-x32-build.patch	2024-04-24 21:18:46.000000000 +0000
+++ 1.16.4-3/debian/patches/0003-fix-alpha-x32-build.patch	2024-05-27 23:24:03.000000000 +0000
@@ -1,40 +1,58 @@
-From 822519192bbccc04b261434c0952bc646381254d Mon Sep 17 00:00:00 2001
-From: Cole Miller <cole.miller@canonical.com>
-Date: Tue, 23 Apr 2024 12:55:50 +0100
-Subject: [PATCH] Three portability fixes around integer width
+From 7dedd6dd72a441f7bb499e9826429abb1e08947b Mon Sep 17 00:00:00 2001
+From: Mathias Gibbens <gibmat@debian.org>
+Date: Fri, 12 Apr 2024 22:24:53 +0000
+Subject: [PATCH 1/2] raft: Fix build on alpha
 
-This unbreaks the dqlite build on alpha and x32.
-
-Co-authored-by: Mathias Gibbens <gibmat@debian.org>
-Signed-off-by: Cole Miller <cole.miller@canonical.com>
+Signed-off-by: Mathias Gibbens <gibmat@debian.org>
 ---
- src/raft/uv_fs.c | 10 ++--------
- src/raft/uv_os.c |  2 +-
- src/tracing.c    |  2 +-
- 3 files changed, 4 insertions(+), 10 deletions(-)
+ src/raft/uv_fs.c | 6 +++++-
+ 1 file changed, 5 insertions(+), 1 deletion(-)
 
 diff --git a/src/raft/uv_fs.c b/src/raft/uv_fs.c
-index b4bf42114..e2e1c8dd4 100644
+index b4bf42114..de380d21d 100644
 --- a/src/raft/uv_fs.c
 +++ b/src/raft/uv_fs.c
-@@ -704,15 +704,9 @@ static int probeDirectIO(int fd, size_t *size, char *errmsg)
+@@ -704,7 +704,11 @@ static int probeDirectIO(int fd, size_t *size, char *errmsg)
  			default:
  				/* UNTESTED: this is an unsupported file system.
  				 */
 -#if defined(__s390x__)
++#if defined(__alpha__)
++				ErrMsgPrintf(errmsg,
++					     "unsupported file system: %x",
++					     fs_info.f_type);
++#elif defined(__s390x__)
+ 				ErrMsgPrintf(errmsg,
+ 					     "unsupported file system: %ux",
+ 					     fs_info.f_type);
+
+From 3822a6d75b2ec581fb74c1875ff52c5299cfcc40 Mon Sep 17 00:00:00 2001
+From: Mathias Gibbens <gibmat@debian.org>
+Date: Fri, 12 Apr 2024 22:25:36 +0000
+Subject: [PATCH 2/2] raft: Fix build on x32
+
+Signed-off-by: Mathias Gibbens <gibmat@debian.org>
+---
+ src/raft/uv_fs.c | 4 ++++
+ src/raft/uv_os.c | 2 +-
+ src/tracing.c    | 2 +-
+ 3 files changed, 6 insertions(+), 2 deletions(-)
+
+diff --git a/src/raft/uv_fs.c b/src/raft/uv_fs.c
+index de380d21d..b3cebd3e3 100644
+--- a/src/raft/uv_fs.c
++++ b/src/raft/uv_fs.c
+@@ -712,6 +712,10 @@ static int probeDirectIO(int fd, size_t *size, char *errmsg)
  				ErrMsgPrintf(errmsg,
--					     "unsupported file system: %ux",
--					     fs_info.f_type);
--#else
--				ErrMsgPrintf(errmsg,
--					     "unsupported file system: %zx",
--					     fs_info.f_type);
--#endif
+ 					     "unsupported file system: %ux",
+ 					     fs_info.f_type);
++#elif defined(__x86_64__) && defined(__ILP32__)
++				ErrMsgPrintf(errmsg,
 +					     "unsupported file system: %llx",
-+					     (unsigned long long)fs_info.f_type);
- 				return RAFT_IOERR;
- 		}
- 	}
++					     fs_info.f_type);
+ #else
+ 				ErrMsgPrintf(errmsg,
+ 					     "unsupported file system: %zx",
 diff --git a/src/raft/uv_os.c b/src/raft/uv_os.c
 index 8a96ab130..a8a972210 100644
 --- a/src/raft/uv_os.c
